

public class DocumentDebugger {

    public DocumentDebugger() {}



    public static void sign(DocumentCanvas D) {
	String S="sign evaluator";
	S=S+"\n\nThis checks on random inputs whether our integer method for evaluating the signs of the Cayley-Menger determinant f on dyadic rational inputs is the same as the floating point method.  Since the method works for f, which is a random polynomial from the point of view of the algorithm, it works for all the polynomials we consider.";

        D.setExplain(S);
        D.repaint();   
	D.Y0=0;
        D.Y1=0;

    }

    public static void misc(DocumentCanvas D) {
	String S="miscellaneous";
	S=S+"\n\nThis routine does different things at different times. I put it in so that I could continue to check features of the program.";

        D.setExplain(S);
        D.repaint();   
	D.Y0=0;
        D.Y1=0;

    }

    public static void cayley(DocumentCanvas D) {
	String S="cayley-menger determinant:"; 
	S=S+"\n\nThis routine checks that we have correctly defined the Cayley-Menger determinant.  We choose 4 random vectors.  Let v be the volume of the tetrahedron having these vectors as vertices.  ";
	S=S+"\n\nWe subtract off the 4th vector and then use the triple product to compute v.  Then we compute 288*v^2";
	S=S+"\n\nWe compute the matrix of distances for the vectors and then use the Cayley-Menger determinant of these distances.  We check that, again, we get 288 v^2, as predicted by the fundamental theorem on the Cayley-Menger determinant.";

        D.setExplain(S);
        D.repaint();   
	D.Y0=0;
        D.Y1=0;

    }

    public static void derivatives(DocumentCanvas D) {
	String S="CM derivatives:\n\n"; 
	S=S+"Let f denote the Cayley-Menger determinant.  We are interested in the 6 partial derivatives of f. These functions are all polynomials, and we store them as lists of coefficients and exponents.  That is, we use our Poly6 class.  We also have floating point versions of the functions.  Finally, we can compute these functions approximately as difference quotients with some small increment.\n\nThis routine checks that the floating point definitions agree to high precision with the difference quotients.  This indicates that we have not made a mistake copying in the formulas we got from Mathematica.  The routine also checks that our Poly6 definition produces the same answer as the floating point version when evaluated on random integer points.  In other words, we have the correct definitions of the directional derivatives of the Cayley-Menger determinant.";
	S=S+"\n\n Finally, we have a routine for computing an arbitrary directional derivative, in the direction of binary integer vectors.  We check that this routine does the right thing for the vector (1,1,1,1,1,1)."; 
        D.setExplain(S);
        D.repaint();   
	D.Y0=0;
        D.Y1=0;

    }


    public static void cubeTransform(DocumentCanvas D) {
	String S="cube transform"; 
	S=S+"\n\n We are interested in showing that an integer polynomial P is non-negative on an integer simplex S.  One step in our algorithm is to produce a surjective polynomial map from [0,1]^5 to S.  The map F carries the vertices of [0,1]^5 to the vertices of S.  We cal the map PF the cube transform of P.  The function PF is non-negative on [0,1]^5 if and only if P is non-negative on S.  We carry out the cube transform on the level of polynomials.  It convertes a Poly6 class into a Poly5 class.  Here a PolyN class is a polynomial in N variables.  In other words, the cube transform is done completely symbolically.";

	S=S+"\n\nThis routine checks that we have got the cube transform correct.  That is, we take an actual polynomial P and that the P(x1)=PF(x0) where x0 is a randomly chosen integer point and x1=F(x0).";

        D.setExplain(S);
        D.repaint();   
	D.Y0=0;
        D.Y1=0;
    }



    public static void dilate(DocumentCanvas D) {
	String S="poly dilate:"; 
	S=S+"\n\n This routine checks that our operation of dilating a polynomial, defined in the paper, is correct.  Again, we compute this in two ways.  First we manipulate the monomials, and then we compute the actual polynomial composition.  We check that the two evaluations agree on randomly chosen integers.";

        D.setExplain(S);
        D.repaint();   
	D.Y0=0;
        D.Y1=0;

    }

    public static void rotate(DocumentCanvas D) {
	String S="poly rotate:"; 
	S=S+"\n\n This routine checks that our operation of rotating a polynomial, defined in the paper, is correct.  The rotation of a polynomial P(a,b,c,d,e) is the polynomial P(b,c,d,e,a), or some similar permutation.  The idea is that we compute the rotation of P in two ways.  On the one hand, we symbolically manipulate the monomials comprising P.  On the other hand, we do the computation straight from the definition just given.  We check that the two values agree on randomly chosen integer vectors.";

        D.setExplain(S);
        D.repaint();   
	D.Y0=0;
        D.Y1=0;

    }


    public static void reflect(DocumentCanvas D) {
	String S="poly reflect:"; 
	S=S+"\n\n This routine checks that our operation of reflecting a polynomial, defined in the paper, is correct.  Again, we compute this in two ways.  First we manipulate the monomials, and then we compute the actual polynomial composition.  We check that the two evaluations agree on randomly chosen integers.";

        D.setExplain(S);
        D.repaint();   
	D.Y0=0;
        D.Y1=0;

    }


    public static void partition(DocumentCanvas D) {
	String S="partition completeness:"; 
	S=S+"\n\n This routine makes the computation needed to prove that the moduli space X of normalized pseudo-tetrahedra is contained in the union of the 14 simplices.   Namely, we check that each interior face of each simplex in the list is the face of a second simplex on the list, and that the hyperplane containing the face separates the two simplices.  We also print out all the indices of the boundary faces.  Finally, we check that the completeness condition is false whenever we omit a simplex from the list.";


        D.setExplain(S);
        D.repaint();   
	D.Y0=0;
        D.Y1=0;

    }



    public static void actionDebug(DocumentCanvas D) {
	String S="debugger";

	S=S+"\n\n This selection brings up the auxiliary menu of debugging features.  Click on the question boxes next to these features to see what they do.";


        D.setExplain(S);
        D.repaint();   
	D.Y0=0;
        D.Y1=0;

    }



}