import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;




public class DocumentIntro {

    public DocumentIntro() {}


    public static void setup(DocumentCanvas D) {
    
	String S="LENGTHENING A TETRAHEDRON\n\n";
        S=S+"Richard Evan Schwartz\n";
	S=S+"program started: 5 June 2014\n";
	S=S+"Last updated:  1 August 2014\n";

	    S=S+"\nNOTES:\n\n1. you can scroll the text in this window by dragging on the window.";

	    S=S+"\n\n2. This text will give you an overview of the program.  If you want to learn in more detail about any given feature on the control panel, click one of the black question boxes.  This will bring up new explanatory text.";

	    S=S+"\n\n3. If you want to return this main text to this window, click on the question box at the top of this window.";


	    S=S+"\n\nPURPOSE OF PROGRAM";
	    S=S+"\n\nThis program is a companion to my paper 'Lengthening a tetrahedron'. My paper proves the following conjecture of Daryl Cooper:  Call a list of lengths tetrahedral if it is the list of edge lengths of some tetrahedron.  If one adds 1 unit to the numbers on the list, one still has a tetrahedral list.  Surprisingly, this was an open problem.  The paper also proves a number of results about whether or not the volume of a tetrahedron increases when you selectively lengthen certain edges.  The answer depends on which edges are chosen and on the shape of the tetrahedron.";

            S=S+"\n\n PSEUDO TETRAHEDRA";
		S=S+"\n\nBefore describing what the program does, I need to make a few definitions.  A pseudo-tetrahedron is a labeling of the tetrahedral graph K4 by non-negative numbers, such that the numbers going around any 3-cycle satisfy the triangle inequality.  We store pseudotetra as lists of 6 numbers:";
		S=S+"\n\n(d01,d02,d03,d12,d13,d34)";
		S=S+"\n\nHere d01 is the label of the edge connecting vertex 0 to vertex 1, and so on.";
		S=S+"\n\nWe normalize our tetrahedra so that the sum of the labels is 24.  The space X of normalized pseudo-tetrahedra is a 5-dimensional convex polytope with integer vertices.  X is triangulated into simplices in various ways, which I'll explain below.";

		S=S+"\n\nCAYLEY-MENGER DETERMINANT";
		S=S+"\n\nSome but not all pseudo-tetrahedra represent actual tetrahedra, in the sense that d01 denotes the distance between points V0 and V1, and so on.  When the pseudo-tetrahedron represents an actual tetrahedron, we call it positive.  There is an extra condition for a pseudo-tetrahedron to be positive: The cayley-menger determinant, which is formed from the 6 numbers, needs to be positive.  The file CayleyMenger.java has the definition of the Cayley-Menger determinent.  I'll denote the Cayley-Menger determinant by f";

		S=S+"\n\nThe beautiful thing about f is that, in case f is evaluated on a positive pseudo-tetrahedron we have the famous relation\n\nf=288(vol)^2\n\nwher vol is the volume of the tetrahedra.  So, computing the directional derivatives of f in various directions is equivalent to studying how the volume changes when the tetrahedron is varied.";

		S=S+"\n\nDIRECTIONAL DERIVATIVES:";

		S=S+"\n\nSuppose that you have chosen some finite subset of the edges of K4.  Such a subset is encoded by a binary vector in R6.  Call this vector V.  For instance, if all edges are chosen, V=(1,1,1,1,1,1).  If just (01) and (02) are chosen, V=(1,1,0,0,0,0).  And so on.  Once V is chosen, we define the function df to be the directional derivative of f in the direction of V.  The whole point of this program is to study f and df.";

		S=S+"\n\nPOSITIVE COMBINATIONS";
		S=S+"\n\nAssuming that the binary vector V has been chosen, we are interested in linear combinations of the form\n\nP=(a)f+(b)df:    b>0\u2265a.  Suppose that S is some simplex in a triangulation of X.  If can show that P\u22650 on S, we have succeeded in showing that df\u22650 whenever f\u22650 at all points of S, including the positive points.  Geometrically, this means that the volume does not decrease when we vary such a tetrahedron by uniformly lengthening the edges corresponding to our binary vector.  The algebraic nature of P guarantees that, in fact, we get a strict increase in the volume.";
		S=S+"\n\nWe call the quadruple (V,a,b,S) a positive input.  What the program lets you do is search for positive inputs and then rigorously certify that a candidate positive input is indeed a positive input.";

		S=S+"\n\nFUNCTION MANAGER";

		S=S+"\n\nYou use the function manager to select the binary vector V and the pair of coefficients (a,b).  You select V by clicking on the column of 6 rectangles.  The orange rectangles represent 1s and the blue rectangles represent 0s.  Once you make a selection, the edges of K4 are colored according to your choice.  You use the blue arrow keys to select the coefficients (a,b).";

		S=S+"\n\nSIMPLEX MANAGER";

		S=S+"\n\nThe space X has 4 separate triangulations.  These triangulations respectively have 3,4,12,48 simplices.  Using the control panel in the simplex manager, you can select one of these triangulations.   The 12-triangulation is the common refinement of the 3-triangulation and the 4-triangulation.  The 48-triangulation is a refinement of the 12-triangulation, in which each simplex has been divided into 4 smaller ones.";

		S=S+"\n\nOnce you select a triangulation, some auxiliary buttons come up, and you select a simplex by clicking on the buttons.  The buttons are arranged canonically, so as to illustrate the refinement structure.  For instance, if you intersect a 3-simplex button A with a 4-simplex button B, you get a 12-simplex button which selects the simplex in the 12-partition which is the intersection of the A-selected simplex and the B-selected simplex.";

		S=S+"\n\nOnce you select a simplex, the vertices of the simplex are printed out beneath the buttons.  Also, the graph K4 is decorated so as to give information about the geometric meaning of the simplices.  You can learn more about this by clicking the question boxes in the simplex manager.";

		S=S+"\n\nEXPERIMENT MODE";

		S=S+"\n\nThere are 3 kinds of experiments you can run in this mode.";

		S=S+"\n\n1. Once you selected an input simplex S, you can test the implication \n\nf\u22650 \u21D2 df\u22650\n\n numerically on random points of S.";

		S=S+"\n\n2. Once you have selected an input (a,b,V,S) using the function manager and the simplex manager, you can see numerically whether this is a good candidate for a positive input.  That is, you can test numerically whether (a)f+(b)df \u22650 on S.";

		S=S+"\n\n3. Once you have selected an input (V,S) you can plot (f,df) for random points on S.";

    S=S+"\n\nFor tests 1 and 2,the experiment mode has a much more useful mode: the group mode.  When you run this mode, you start out with a list of all 48 simplices in the 48-partition.  The program then tests these simplices on random inputs, and crosses any simplex off the list where the test fails.  The squares corresponding to the survivors are colored blue. So, as the routine progresses, the blue squares gradually disappear.  The long-term survivors are good candidates for success.  I noticed, however, that sometimes you have to wait about 100 million steps before some of the blue squares disappear.";

    S=S+"\n\nCERTIFY MODE";

    S=S+"\n\nOnce you have selected a candidate positive input (a,b,V,S), you can use the certify mode to rigorously give a certificate of non-negativity.  Click on the question box by the certify option to read about it in detail. I call my algorithm 'the method of positive dominance'. Here is a rough outline. Say that my polynomial is P and my simplex is S.  I construct a canonical surjective polynomial map M from the unit cube [0,1]^5 to S, and then consider the composition Q=PF.  Q is non-negative on the unit cube if and only if P is non-negative on the simplex S.  I then use a divide-and-conquer algorithm to establish the nonnegativity of Q.";

    S=S+"\n\nYou can either run the certify mode for single inputs or for a group of then. In the group mode, the program considers the given function on all simplices corresponding to blue squares on the 48-partition control.  So, you would typically use this option after running the experiment mode.";

    S=S+"\n\nANTICERTIFY MODE";

    S=S+"\n\nIf you have selected some simplices, and a combination (a)f+(b)df, the test in this mode will try random points in each simplex and try to find a point where the combination is negative.  If this happens, the program will turn the corresponding square on the selector magenta.  This test is rigorous in that the program finds a point with rational coordinates and computes the value exactly.";

	    S=S+"\n\nDEBUGGER MODE";

	    S=S+"\n\nIn the debugger mode, you will see an auxiliary control panel.  This control panel has 7 debugging options, which check various features of the program.  The first 6 check our main calculations, and the last one is present just so I can fool around with the program and add new features.  You can learn more about what the debugger checks by clicking on the black question boxes beside the options.";

	    S=S+"\n\nThe debugging portion of the program is meant to be run on a window which has a command line output.";


        D.setExplain(S);
        D.repaint();   
	D.Y0=0;
        D.Y1=0;

    }
}

