import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


public class Experimenter implements Runnable {
    PictureCanvas P;
    boolean HALT;
    int CHOICE;

    public Experimenter() {
	HALT=true;
    }

    public Experimenter(PictureCanvas PP) {
	HALT=true;
	this.P=PP;
	CHOICE=P.EXP.mode;

    }

    /**Main routine*/
    public void run() {
	int c=P.GROUP.mode;
	int d=P.EXP.mode;
	if(CHOICE<2) {
	   if(c==0) positivitySingle();
  	   if(c==1) positivityGroup();
	}
	if(CHOICE==2) doPlot();
    }

    /**This runs the tests in single mode*/
    public void positivitySingle() {
	System.out.println("START");
	HALT=false;
	int[] S=P.SM.N48;
	int[] q=P.FM.getDiff();
	int a0=P.FM.LIN[0].val;
	int a1=P.FM.LIN[1].val;
	long count=0;
	P.STEPS=0;
	P.repaint();
	while(HALT==false) {
	 ++count;
	 boolean test=randomCheck(S,q,a0,a1);
	 if(test==false) {
	     HALT=true;
	     for(int i=0;i<3;++i) System.out.println("");
	     System.out.println("fail");
	     for(int i=0;i<3;++i) System.out.println("");
	     P.SM.S48[S[0]][S[1]][S[2]][S[3]].state=0;
	 } 
        if(count%100000==0) P.STEPS=count;
	 P.repaint();
	}
    }

    /**This runs the tests in group mode*/
    public void positivityGroup() {
	HALT=false;	
        int[][] LIST=initialList();
	int[] RECORD=new int[LIST.length];
	int[] q=P.FM.getDiff();
	int a0=P.FM.LIN[0].val;
	int a1=P.FM.LIN[1].val;
	long count=0;
	P.repaint();
	while(HALT==false) {
	    ++count;
	    int n=LIST.length;
	    int k=random(n);
	    int[] S=LIST[k];
	    boolean test=randomCheck(S,q,a0,a1);
	    if(test==false) LIST=omit(LIST,k);
	    if(count%100000==0) P.STEPS=count;
	    P.repaint();
	    if(LIST.length==0) HALT=true;
	}
    }


    public boolean randomCheck(int[] S,int[] q,int a,int b) {
	if(CHOICE==0) return randomCheck0(S,q);
	if(CHOICE==1) return randomCheck1(S,q,a,b);
	return(true);
    }

    public boolean randomCheck0(int[] S,int[] q) {
	double[] t=ModuliSpace2.randomInside(S[0],S[1],S[2],S[3]);
	double f=CayleyMenger.f(t);
	double g=CayleyMenger.df(q,t);
	if((f>0)&&(g<0)) return(false);
	return(true);
    }

    public boolean randomCheck1(int[] S,int[] q,int a,int b) {
	double[] t=ModuliSpace2.randomInside(S[0],S[1],S[2],S[3]);
	double f=CayleyMenger.f(t);
	double g=CayleyMenger.df(q,t);
	double h=a*f+b*g;
	if(h<=0) return(false);
	return(true);
    }

    public int[][] omit(int[][] LIST,int q) {
	int n=LIST.length;
	int[][] LIST2=new int[n-1][4];
	int c=0;
	for(int i=0;i<n;++i) {
	    if(i!=q) {
		for(int j=0;j<4;++j) LIST2[c][j]=LIST[i][j];
		++c;
	    }
	}
	int i=LIST[q][0];
	int j=LIST[q][1];
	int k=LIST[q][2];
	int l=LIST[q][3];
	P.SM.S48[i][j][k][l].state=0;
	return(LIST2);
    }

    public int[][] initialList() {
	int[][] LIST=new int[48][8];
	int c=0;
	for(int i=0;i<4;++i) {
	    for(int j=0;j<4;++j) {
		for(int k=0;k<2;++k) {
		    for(int l=0;l<2;++l) {
			if(i!=j) {
			    int[] I={i,j,k,l};
			  P.SM.S48[i][j][k][l].state=1;
			  LIST[c]=I;
			  ++c;
			}
		    }
		}
	    }
	}
	return(LIST);
    }




    public void doPlot() {
	doPlot0();
	doPlot1();
	doPlot2();
    }


    /**This plots the lines connecting the 
       vertices*/

    public double[] basisVector(int i) {
	double[] x=new double[6];
	x[i]=1;
	return(x);
    }

    public double[] basisVectorInterpolate(int i,int j,double s) {
	double[] x1=basisVector(i);
	double[] x2=basisVector(j);
	double[] y=new double[6];
	for(int k=0;k<6;++k) y[k]=(1-s)*x1[k]+s*x2[k];
	return(y);
    }


    /**This just plots the straight lines connecting the
       images of the vertices*/

    public void doPlot0() {
	int[] q=P.FM.getDiff();
	int[][] a=P.SM.getSimplex();
	GeneralPath gp=new GeneralPath();
	for(int i=0;i<6;++i) {
	    for(int j=i+1;j<6;++j) {
		double[] e1=basisVector(i);
		double[] e2=basisVector(j);
		double[] t1=ModuliSpace2.map(a,e1);
		double[] t2=ModuliSpace2.map(a,e2);
	        double x1=CayleyMenger.f(t1);
	        double y1=CayleyMenger.df(q,t1);
	        double x2=CayleyMenger.f(t2);
	        double y2=CayleyMenger.df(q,t2);
		gp.moveTo((float)(x1),(float)(y1));
		gp.lineTo((float)(x2),(float)(y2));
	    }
	}
	P.LINE=new GeneralPath(gp);
    }


    public void doPlot1() {
	int[] q=P.FM.getDiff();
	int[][] a=P.SM.getSimplex();
	GeneralPath gp=new GeneralPath();
	for(int i=0;i<6;++i) {
	    for(int j=i+1;j<6;++j) {
		for(int k=0;k<=100;++k) {
		    double[] t=basisVectorInterpolate(i,j,1.0*k/100);
	            t=ModuliSpace2.map(a,t);
	            double x=CayleyMenger.f(t);
	            double y=CayleyMenger.df(q,t);
		    if(k==0) gp.moveTo((float)(x),(float)(y));
		    if(k!=0) gp.lineTo((float)(x),(float)(y));
		}
	    }
	}
        P.ARC=new GeneralPath(gp);
    }



    public void doPlot2() {
	int n=P.PLOTNUMBER.val;
	double N=Math.pow(2,n);
	P.COUNT=0;
	HALT=false;
	int count=0;
	int[] q=P.FM.getDiff();
	int a0=P.FM.LIN[0].val;
	int a1=P.FM.LIN[1].val;
	while(HALT==false) {
	    double[] t=randomUnit();
	    Complex z=location(q,a0,a1,t);
	    P.PLOT[P.COUNT]=new Complex(z);
	    ++P.COUNT;
	    if(count%100==0) P.repaint();
	    ++count;
	    if(count>N-2) HALT=true;
	}
    }



    public Complex location(int[] q,int a,int b,double[] t) {
	int[][] M=P.SM.getSimplex();
	double[] u=ModuliSpace2.map(M,t);
	double f=CayleyMenger.f(u);
	double g=CayleyMenger.df(q,u);
	Complex z=new Complex(f,g);
	return(z);
    }



    /**This picks a random vector in the unit cube,
       but biases the vector so that usually it
       lies in the boundary of the cube. */


    public double[] randomUnit() {
	 double[] u=new double[6];
	 for(int q=0;q<6;++q) u[q]=Math.random();
	 for(int v=0;v<6;++v) {
	     if(Math.random()>.5) u[v]=0;
	 }
	 double sum=0;
	 for(int q=0;q<6;++q) sum=sum+u[q];
	 for(int q=0;q<6;++q) u[q]=u[q]/sum;
	 return(u);
    }


    public int random(int n) {
	double x=Math.random();
	int m=(int)(Math.floor(n*x));
	return(m);
    }

    public void printout(int[][] LIST) {
	for(int i=0;i<LIST.length;++i) {
	    Debugger.printout(LIST[i]);
	}
    }



}





