import java.applet.Applet;
import java.awt.event.*;
import java.awt.*;
import java.math.*;


public class Mono6 {
    BigInteger c;
    int[] e=new int[6];

    public Mono6() {}

    public Mono6(Mono6 a) {
	this.c=new BigInteger(a.c.toString());
	for(int i=0;i<6;++i) this.e[i]=a.e[i];
    }

    public Mono6(int c0,int[] ee) {
	c=copy(c0);
	for(int i=0;i<6;++i) e[i]=ee[i];
    }

    public Mono6(BigInteger c0,int[] ee) {
	c=new BigInteger(c0.toString());
	for(int i=0;i<6;++i) e[i]=ee[i];
    }


    public Mono6 rotate(int r) {
	Mono6 m=new Mono6();
	m.c=new BigInteger(c.toString());
	for(int i=0;i<6;++i) {
	    int j=(i+6+r)%6;
	    m.e[j]=e[i];
	}
	return(m);
    }

    public static BigInteger copy(int a) {
	Integer A=new Integer(a);
	BigInteger AA=new BigInteger(A.toString());
	return(AA);
    }
    public static BigInteger copy(long a) {
	Long A=new Long(a);
	BigInteger AA=new BigInteger(A.toString());
	return(AA);
    }


    /**evaluation on integer vectors. This is for debugging purposes*/
    public BigInteger evaluate(int[] x) {
	BigInteger a=new BigInteger(c.toString());
	for(int i=0;i<6;++i) {
	    for(int j=0;j<e[i];++j) {
		a=a.multiply(copy(x[i]));
	    }
	}
	return(a);
    }
    /**this avoids overflow error in our anticertify routine*/

    public BigInteger evaluate(BigInteger[] x) {
	BigInteger a=new BigInteger(c.toString());
	for(int i=0;i<6;++i) {
	    for(int j=0;j<e[i];++j) {
		a=a.multiply(x[i]);
	    }
	}
	return(a);
    }

    public static Mono6 times(Mono6 A,Mono6 B) {
	Mono6 C=new Mono6();
	C.c=A.c.multiply(B.c);
	for(int i=0;i<6;++i) C.e[i]=A.e[i]+B.e[i];
	return(C);
    }

    public static Mono6 random() {
	Mono6 m=new Mono6();
	int c=random(100);
	Integer C=new Integer(c);
	m.c=new BigInteger(C.toString());
	for(int i=0;i<6;++i) m.e[i]=random(4);
	return(m);
    }

    public static int random(int n) {
	double y=Math.floor(n*Math.random());
	int k=(int)(y);
	return(k);
    }

    /**printouts*/
    public void print() {
	System.out.print("{"+c.toString()+",{");
	for(int i=0;i<6;++i) {
	    System.out.print(e[i]);
	    if(i<5) System.out.print(",");
	    if(i==5) System.out.print("}");
	}
	System.out.print("}");
    }


    public void print(Output OUT) {
	OUT.print("{"+c.toString()+",{");
	for(int i=0;i<6;++i) {
	    OUT.print(e[i]);
	    if(i<5) OUT.print(",");
	    if(i==5) OUT.print("}");
	}
	OUT.print("}");
    }





    public void println() {
	this.print();
	System.out.println("");
    }
}




